<?php
defined('BASEPATH') OR exit('No direct script access allowed');



class AuthController extends CI_Controller {

	private $msg;
	
    function __construct() {
        parent::__construct();
		$this->lang->load('msg');
		$this->load->library('AuthLibrary');
        $this->load->library('form_validation');
    }
	
    private function display_msg($msg) {
        $this->msg .= $msg . nl2br("\n");
    }
	
	function index() {
		//$this->load->view('home');
		if (!$this->authlibrary->is_logged_in()) {
            
            redirect(base_url().'admin');
        } else {
			
            redirect(base_url().'puzzle_list');
		}
	}
	
	function login() 
    { 
        //dsm($_POST);
        if ($this->input->post('login'))
        {
            $this->form_validation->set_rules('username', 'Username', 'trim|required|max_length[100]');
            $this->form_validation->set_rules('password', 'Password', 'trim|required|max_length[25]');
            if ($this->form_validation->run()) 
            {        // validation ok
				$username = $this->input->post('username');
                $password = $this->input->post('password');
                if ($this->authlibrary->login($username, $password)) 
                {        
                    // success
                    $this->session->set_flashdata($this->config->item('msg_key'), $this->lang->line('login_success'));
                    $this->session->keep_flashdata($this->config->item('msg_key'));
                    redirect(base_url().'puzzle_list');
                } 
                else 
                {
                    $errors = $this->authlibrary->get_error_message();
                    $this->display_msg($errors);
                }
            }
        }
        $data['errors'] = $this->msg;
        $data['msg'] = '';
        if ($message = $this->session->flashdata($this->config->item('msg_key'))) {
            $data['msg'] = $message;
        }
        $this->load->view('admin/login', $data);
    }
	
    function logout() {
        if ($this->authlibrary->is_logged_in()) {
            $this->authlibrary->logout();
            $this->session->set_flashdata($this->config->item('msg_key'), $this->lang->line('logout_success'));
            $this->session->keep_flashdata($this->config->item('msg_key'));
        }
        redirect('admin');
        //$this->load->view('login/logout');
    }
}
