<?php
defined('BASEPATH') OR exit('No direct script access allowed');



class Backend extends CI_Controller {
	
	 function __construct() {
        parent::__construct();
        
		 $this->load->library('form_validation');
		 $this->load->model('MasterModel');
		 $this->load->library('email');
    }


    public function puzzle_list()
    {
    	$data['title'] = "Puzzle list";
    	$data['puzzle_list'] = $this->MasterModel->get_puzzle();
		$data['file_name'] = 'admin/puzzle-list';
		$this->load->view('admin/master', $data);
    }
	
	public function puzzle_add($puzzle_id=false)
    {
    	$data['title'] = "Puzzle Add";
    	$data['genre_list'] =$this->MasterModel->get_genre();
    	$data['level_list'] =$this->MasterModel->get_level();
    	$puzz_number = $this->MasterModel->get_puzzle_number();
    	$data['puzzle_number'] = $puzz_number[0]['new_puzzle_number'];
    	if(!empty($puzzle_id))
		{
			$data['title'] = "Edit Puzzle";
			$data['puzzle_id'] = $puzzle_id;
			$filter_puzzle['puzzle.puzzle_id']=$puzzle_id;
			$data['edit_data'] = $this->MasterModel->get_puzzle($filter_puzzle);
		}
		$data['file_name'] = 'admin/puzzle-add';
		$this->load->view('admin/master', $data);
    }

    function puzzle_save($puzzle_id=false) 
    {
    	$this->db->trans_begin();
    	$post_array = $this->input->post();
    	$statusMsg = ''; 
// File upload directory 
    	$targetDir = "crossword-assets/js/"; 

    	$puzzle_id = $this->input->post('puzzle_id');


    	if(!empty($_FILES["file"]["name"]))
    	{ 
    		$fileName = basename($_FILES["file"]["name"]); 
    		$targetFilePath = $targetDir . $fileName; 
    		$fileType = pathinfo($targetFilePath,PATHINFO_EXTENSION); 
    		$puzzle_data = array(
    			'puzzle_name' => $post_array['puzzle_name'],
    			'puzzle_JS_file' => $fileName,
    			'puzzle_number' => $post_array['puzzle_number'],
    			'puzzle_genre_id' => $post_array['puzzle_genre_id'],
    			'puzzle_level_id' => $post_array['puzzle_level_id'],
    			// 'puzzle_iframe_url' => $post_array['puzzle_iframe_url'],
    			'puzzle_date' => date('Y-m-d', strtotime($post_array['puzzle_date'])),

    		);
		// Allow certain file formats 
    		$allowTypes = array('js'); 
    		if(in_array($fileType, $allowTypes))
    		{ 
				// Upload file to server 
    			if(move_uploaded_file($_FILES["file"]["tmp_name"], $targetFilePath))
    			{ 
    				if (!empty($puzzle_id)) 
    				{
    					$insert = $this->MasterModel->update_puzzle($puzzle_data, $puzzle_id);
    				}
    				else
    				{
    					$where['WHERE'] =" puzzle_number = ".$post_array['puzzle_number']." or puzzle_JS_file = '".$fileName."'";
    					$isExists = $this->MasterModel->is_Puzzle_exists($where);
    					//dsm($isExists);die;
    					if(sizeof($isExists) > 0)
    					{
    						$statusMsg = "Filename ".$fileName." or Puzzle number ".$post_array['puzzle_number']." found Duplicate"; 
    						$this->db->trans_rollback();
    						$this->session->set_flashdata('error',$statusMsg);
    						redirect_back();
    					}
    					else
    					{
    						$insert=$this->MasterModel->add_puzzle($puzzle_data);
    					}
    					
    				}
						// Insert js file name into database 
    				if($insert)
    				{ 
    					$this->db->trans_commit();
    					$statusMsg = "The Data has been uploaded successfully."; 
    					$this->session->set_flashdata('success',$statusMsg);
    					redirect('puzzle_list');
    				}
    				else
    				{ 
    					$statusMsg = "File upload failed, please try again."; 
    					$this->db->trans_rollback();
    					$this->session->set_flashdata('error',$statusMsg);
    					redirect_back();


    				}  
    			}else{ 
    				$statusMsg = "Sorry, there was an error uploading your file."; 
    				$this->db->trans_rollback();
    				$this->session->set_flashdata('error',$statusMsg);
    				redirect_back();
    			} 
    		}
    		else
    		{ 
    			$statusMsg = 'Sorry, only JS files are allowed to upload.'; 
    			$this->db->trans_rollback();
    			$this->session->set_flashdata('error',$statusMsg);
    			redirect_back();
    		} 
    	}else{ 
    		$statusMsg = 'Please select a file to upload.'; 
    		$this->db->trans_rollback();
    		$this->session->set_flashdata('error',$statusMsg);
    		redirect_back();
    	} 



	}
    public function genre_list()
    {
    	$data['title'] = "Genre list";
    	$data['genre_list'] =$this->MasterModel->get_genre();
		$data['file_name'] = 'admin/genre-list';
		$this->load->view('admin/master', $data);
    }
	
	public function genre_add($genre_id=false)
    {
    	$data['title'] = "Genre Add";
    	$data['genre_list'] =$this->MasterModel->get_genre();
    	if(!empty($genre_id))
		{
			$data['title'] = "Edit Genre";
			$data['genre_id'] = $genre_id;
			$filter_genre['genre.genre_id']=$genre_id;
			$data['edit_data'] = $this->MasterModel->get_genre($filter_genre);
		}
		$data['file_name'] = 'admin/genre-add';
		$this->load->view('admin/master', $data);
    }

    function genre_save($genre_id=false) 
    {

		$post_array = $this->input->post();

		$genre_id = $this->input->post('genre_id');
		$this->form_validation->set_rules('genre_name', 'Genre Name', 'required'); 

		if ($this->form_validation->run() == FALSE) { 
			set_message(validation_errors());
			// $this->session->set_flashdata('old_data',$this->input->post());
			redirect_back();
		} 
		else { 
			$genre_data = array(
				'genre_name' => $post_array['genre_name'],

			);

			$this->db->trans_begin();

			if (!empty($genre_id)) 
			{
				$update_id = $this->MasterModel->update_genre($genre_data, $genre_id);
			}
			else
			{
				$insert_id=$this->MasterModel->add_genre($genre_data);
			}
		}

		/* Check transaction status */
		if($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();
			set_message("Something went wrong, Please try again");
			$this->session->set_flashdata('old_data',$post_array);
			redirect_back();
		}
		else {
			$this->db->trans_commit();


			$this->session->set_flashdata('success','Data Updated Successfully!!!');
			redirect('genre_list');

		}

	}

    public function level_list()
    {
    	$data['title'] = "Puzzle Level list";
    	$data['level_list'] =$this->MasterModel->get_level();
		$data['file_name'] = 'admin/level-list';
		$this->load->view('admin/master', $data);
    }
	
	public function level_add($level_id=false)
    {
    	$data['title'] = "Puzzle Level Add";
    	$data['level_list'] =$this->MasterModel->get_level();
    	if(!empty($level_id))
		{
			$data['title'] = "Edit level";
			$data['level_id'] = $level_id;
			$filter_level['level.level_id']=$level_id;
			$data['edit_data'] = $this->MasterModel->get_level($filter_level);
		}
		$data['file_name'] = 'admin/level-add';
		$this->load->view('admin/master', $data);
    }

    function level_save($level_id=false) 
    {

		$post_array = $this->input->post();

		$level_id = $this->input->post('level_id');
		$this->form_validation->set_rules('level_name', 'level Name', 'required'); 

		if ($this->form_validation->run() == FALSE) { 
			set_message(validation_errors());
			// $this->session->set_flashdata('old_data',$this->input->post());
			redirect_back();
		} 
		else { 
			$level_data = array(
				'level_name' => $post_array['level_name'],

			);

			$this->db->trans_begin();

			if (!empty($level_id)) 
			{
				$update_id = $this->MasterModel->update_level($level_data, $level_id);
			}
			else
			{
				$insert_id=$this->MasterModel->add_level($level_data);
			}
		}

		/* Check transaction status */
		if($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();
			set_message("Something went wrong, Please try again");
			$this->session->set_flashdata('old_data',$post_array);
			redirect_back();
		}
		else {
			$this->db->trans_commit();


			$this->session->set_flashdata('success','Data Updated Successfully!!!');
			redirect('level_list');

		}

	}

	
	public function comment_list()
    {
    	$comment_puzzle_id = $this->input->post('comment_puzzle_id');

    	$where['WHERE'] =" comment_puzzle_id = ".$comment_puzzle_id."";
    	$list =$this->MasterModel->get_comments($where);
    	echo json_encode($list);
		
    }


    function feedback_save($comment_id=false) 
    {

		$post_array = $this->input->post();

		$comment_id = $this->input->post('comment_id');
		$comment_puzzle_id = $this->input->post('comment_puzzle_id');
		$comment_description = $this->input->post('comment_description');
		$comment_by_name = $this->input->post('comment_by_name');
		$comment_by_email = $this->input->post('comment_by_email');
		$comment_by_datetime = strtotime(date("Y-m-d H:i:s "));
		


		 
			$comment_data = array(
				'parent_comment_id' => $comment_id,
				'comment_puzzle_id' => $comment_puzzle_id,
				'comment_description' => $comment_description,
				'comment_by_name' => $comment_by_name,
				'comment_by_email' => $comment_by_email,
				'comment_by_datetime' => $comment_by_datetime,

			);

			$this->db->trans_begin();

			
			
				$insert_id=$this->MasterModel->add_comment($comment_data);
			
		

		/* Check transaction status */
		if($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();

			$response = array('status'=>1,'message'=>'Something Went Wrong');
			echo json_encode($response);
			
		}
		else {
			$this->db->trans_commit();
			$response = array('status'=>0,'message'=>'Thank You! Your feedback is valuable for us');
			echo json_encode($response);


		}

	}

    public function edit_profile()
    {
    	$data['title'] = "Edit Profile";
		$data['file_name'] = 'admin/edit-profile';
		$this->load->view('admin/master', $data);
    }
}
?>