<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/userguide3/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$route['default_controller'] = 'Front';
$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;
$route['admin'] = "AuthController/login";
$route['logout'] = "AuthController/logout";

$route['puzzle_list'] = 'Backend/puzzle_list';
$route['puzzle_add'] = 'Backend/puzzle_add';
$route['puzzle_save'] = 'Backend/puzzle_save';
$route['puzzle_edit/(:any)'] = 'Backend/puzzle_add/$1';

$route['genre_list'] = 'Backend/genre_list';
$route['genre_add'] = 'Backend/genre_add';
$route['genre_save'] = 'Backend/genre_save';
$route['genre_edit/(:any)'] = 'Backend/genre_add/$1';

$route['level_list'] = 'Backend/level_list';
$route['level_add'] = 'Backend/level_add';
$route['level_save'] = 'Backend/level_save';
$route['level_edit/(:any)'] = 'Backend/level_add/$1';

$route['blog_list'] = 'Backend/blog_list';
$route['blog_add'] = 'Backend/blog_add';
$route['blog_save'] = 'Backend/blog_save';
$route['blog_edit/(:any)'] = 'Backend/blog_add/$1';

$route['comment_list'] = 'Backend/comment_list';
$route['feedback_save'] = 'Backend/feedback_save';
$route['edit_profile'] = 'Backend/edit_profile';

// 


$route['(:num)'] = 'Front/index/$1';
$route['about_us'] = 'Front/about_us';
$route['article'] = 'Front/article';


