<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class MasterModel extends CI_Model {

    public function __construct() {
        parent::__construct();
        date_default_timezone_set('Asia/Kolkata');

    }
// ********Puzzle Section***********

    public function add_puzzle($data) {

        $this->db->insert('puzzle',$data); 
        return $this->db->insert_id();
    }

    public function update_puzzle($data, $edit_id) {
        $this->db->where('puzzle_id',$edit_id);
        return $this->db->update('puzzle',$data);
    } 

    public function get_puzzle($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }
        $this->db->join('level','level.level_id = puzzle.puzzle_level_id','left');
        $this->db->join('genre','genre.genre_id = puzzle.puzzle_genre_id','left');
        $this->db->where('puzzle_deleted_flag',false);
        $this->db->order_by('puzzle_name',"ASC");
        $rs=$this->db->get('puzzle');
//lq();exit;
        return $rs->result_array();
    }

    public function is_Puzzle_exists($filter=false) {    
        
        if($filter) {
            apply_filter($filter);
        }
        
        $rs=$this->db->get('puzzle');
        return $rs->result_array();
    }

    public function get_puzzle_number()
    {
        $this->db->select('if(isnull(max(puzzle_number)),1,(max(puzzle_number)+1)) as new_puzzle_number');
        $this->db->from('puzzle');
        $this->db->where('puzzle_deleted_flag', false);
        $rs = $this->db->get();
        return $rs->result_array();
    }
    public function get_todays_puzzle($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }
        $this->db->join('level','level.level_id = puzzle.puzzle_level_id','left');
        $this->db->join('genre','genre.genre_id = puzzle.puzzle_genre_id','left');
        $this->db->where('puzzle_deleted_flag',false);
        $this->db->order_by('puzzle_date',"DESC");
        $rs=$this->db->get('puzzle');
//lq();exit;
        return $rs->result_array();
    }

    public function get_latest_puzzle($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }
        $this->db->join('level','level.level_id = puzzle.puzzle_level_id','left');
        $this->db->join('genre','genre.genre_id = puzzle.puzzle_genre_id','left');
        $this->db->where('puzzle_deleted_flag',false);
        $this->db->order_by('puzzle_date',"DESC");
        $rs=$this->db->get('puzzle');
//lq();exit;
        return $rs->result_array();
    }

// ********genre Section***********

    public function add_genre($data) {

        $this->db->insert('genre',$data); 
        return $this->db->insert_id();
    }

    public function update_genre($data, $edit_id) {
        $this->db->where('genre_id',$edit_id);
        return $this->db->update('genre',$data);
    } 

    public function get_genre($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->where('genre_deleted_flag',false);
        $rs=$this->db->get('genre');
        return $rs->result_array();
    }
    
   
// ********level Section***********

    public function add_level($data) {

        $this->db->insert('level',$data); 
        return $this->db->insert_id();
    }

    public function update_level($data, $edit_id) {
        $this->db->where('level_id',$edit_id);
        return $this->db->update('level',$data);
    } 

    public function get_level($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->where('level_deleted_flag',0);
        $rs=$this->db->get('level');
        return $rs->result_array();
    }

    public function add_comment($data) {

        $this->db->insert('comment',$data); 
        return $this->db->insert_id();
    }

    public function get_comments($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->order_by('parent_comment_id,comment_id');
        $rs=$this->db->get('comment');
        return $rs->result_array();
    }
}


